import { signed } from '../utils/big-varint.js';
import { createCodec, CODEC_TYPES } from './codec.js';
const encodingLength = function int64EncodingLength(val) {
    return signed.encodingLength(val);
};
const encode = function int64Encode(val) {
    const buf = new Uint8Array(encodingLength(val));
    signed.encode(val, buf);
    return buf;
};
const decode = function int64Decode(buf, offset) {
    return signed.decode(buf, offset) | 0n;
};
export const int64 = createCodec('int64', CODEC_TYPES.VARINT, encode, decode, encodingLength);
//# sourceMappingURL=int64.js.map